//+------------------------------------------------------------------+
//|                                                      Awesome.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2005, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Black
#property  indicator_color2  Red
#property  indicator_color3  Blue

//
//
//
//
//

extern int     FastMaPeriod        = 5;
extern int     FastMaMode          = MODE_EMA;
extern int     FastMaPrice         = PRICE_MEDIAN;
extern int     SlowMaPeriod        = 34;
extern int     SlowMaMode          = MODE_EMA;
extern int     SlowMaPrice         = PRICE_MEDIAN;
//extern int     SignalPeriod        = 5;
//extern int     SignalShift         = 0;

//---- indicator buffers
double     ExtBuffer0[];
double     ExtBuffer1[];
double     ExtBuffer2[];
//  ,     
extern bool AlertsOn        = true,
            EmailOn = false,
            AlertOnClosedCandle = true,
            AlertOnColorChange = true,
            AlertOnZeroCross = true,
            ShowArrows = true;
extern color ColorChangeUp = Green,
             ColorChangeDn = Red,
             ZeroCrossUp = Blue,
             ZeroCrossDn = Yellow;
extern int   ArrowWidth = 2;                         
            
datetime Alerted = 0, Alerted1=0,PrevTime;
int SIGNAL_BAR = 0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   //---- drawing settings
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,4);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,4);
   IndicatorDigits(Digits+1);
   SetIndexDrawBegin(0,34);
   SetIndexDrawBegin(1,34);
   SetIndexDrawBegin(2,34);
//---- 3 indicator buffers mapping
   SetIndexBuffer(0,ExtBuffer0);
   SetIndexBuffer(1,ExtBuffer1);
   SetIndexBuffer(2,ExtBuffer2);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("AO");
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
//---- initialization done
   if (AlertOnClosedCandle) SIGNAL_BAR=1;
   return(0);
  }
  
//added by sangmane
int deinit()
  {
  int    obj_total=ObjectsTotal();
  string name;
  for(int ik=obj_total-1;ik>=0;ik--)
    {
     name=ObjectName(ik);
     int index = StringFind(name,"AO_alert1",0);
     if(index>=0)
       ObjectDelete(name);
    }
  }  
 //////  
//+------------------------------------------------------------------+
//| Awesome Oscillator                                               |
//+------------------------------------------------------------------+
int start()
  {
   int    limit;
   int    counted_bars=IndicatorCounted();
   double prev,current;
   string label;
   bool res;
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd
   for(int i=0; i<limit; i++)
      ExtBuffer0[i]=iMA(NULL,0,FastMaPeriod,0,FastMaMode,FastMaPrice,i)-iMA(NULL,0,SlowMaPeriod,0,SlowMaMode,SlowMaPrice,i);
//---- dispatch values between 2 buffers
   bool up=true;
   for(i=limit-1; i>=0; i--)
     {
      current=ExtBuffer0[i];
      prev=ExtBuffer0[i+1];
      if(current>prev) up=true;
      if(current<prev) up=false;
      if(!up)
        {
         ExtBuffer2[i]=current;
         ExtBuffer1[i]=0.0;
        }
      else
        {
         ExtBuffer1[i]=current;
         ExtBuffer2[i]=0.0;
        }
     if (ShowArrows) {
         if (ExtBuffer0[i+SIGNAL_BAR]>ExtBuffer0[i+1+SIGNAL_BAR] && ExtBuffer0[i+2+SIGNAL_BAR]>ExtBuffer0[i+1+SIGNAL_BAR]) DrawArrow (i+SIGNAL_BAR,ColorChangeUp,233,false);
         if (ExtBuffer0[i+SIGNAL_BAR]<ExtBuffer0[i+1+SIGNAL_BAR] && ExtBuffer0[i+2+SIGNAL_BAR]<ExtBuffer0[i+1+SIGNAL_BAR]) DrawArrow (i+SIGNAL_BAR,ColorChangeDn,234,true);
         if (ExtBuffer0[i+SIGNAL_BAR]>0 && ExtBuffer0[i+1+SIGNAL_BAR]<=0) DrawArrow (i+SIGNAL_BAR,ZeroCrossUp,233,false);
         if (ExtBuffer0[i+SIGNAL_BAR]<0 && ExtBuffer0[i+1+SIGNAL_BAR]>=0) DrawArrow (i+SIGNAL_BAR,ZeroCrossDn,234,true);
         }
     }
	  if (AlertsOn) {
	     if(ExtBuffer0[SIGNAL_BAR]>ExtBuffer0[SIGNAL_BAR+1] && ExtBuffer0[SIGNAL_BAR+2]>ExtBuffer0[SIGNAL_BAR+1]) {
            if (Alerted!=Time[0]) {
               Alerted=Time[0];
               Alert("Awesome (", Symbol(), ", ", Period(), ") turned up!!!");
               SendMail("AO Buy Alert!","Awesome ("+Symbol()+", "+Period()+") turned up!!!");
               }
            }
        if (ExtBuffer0[SIGNAL_BAR]<ExtBuffer0[SIGNAL_BAR+1] && ExtBuffer0[SIGNAL_BAR+2]<ExtBuffer0[SIGNAL_BAR+1]) {
            if (Alerted!=Time[0]) {
               Alerted=Time[0];
               Alert("Awesome (", Symbol(), ", ", Period(), ") turned down!!!");
               SendMail("AO Sell Alert!","Awesome ("+Symbol()+", "+Period()+") turned down!!!");
               }
            }
        if (ExtBuffer0[SIGNAL_BAR]>0 && ExtBuffer0[SIGNAL_BAR+1]<=0) {
            if (Alerted1!=Time[0]) {
               Alerted1=Time[0];
               Alert("Awesome (", Symbol(), ", ", Period(), ") crossed up 0!!!");
               SendMail("AO Buy Alert!","Awesome ("+Symbol()+", "+Period()+") crossed up 0!!!");
               }
            }
        if (ExtBuffer0[SIGNAL_BAR]<0 && ExtBuffer0[SIGNAL_BAR+1]>=0) {
            if (Alerted1!=Time[0]) {
               Alerted1=Time[0];
               Alert("Awesome (", Symbol(), ", ", Period(), ") crossed down 0!!!");
               SendMail("AO Sell Alert!","Awesome ("+Symbol()+", "+Period()+") crossed down 0!!!");
               }
            }  
        }
   return(0);
  }
//+------------------------------------------------------------------+
void DrawArrow(int i, color theColor,int theCode,bool up) {
   string name = "AO_alert1:"+Time[i];
   double gap  = 3.0*iATR(NULL,0,20,0)/4.0;   
   if (ObjectFind(name)<0) ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
      ObjectSet(name,OBJPROP_ARROWCODE,theCode);
      ObjectSet(name,OBJPROP_COLOR,theColor);
      ObjectSet(name,OBJPROP_WIDTH,ArrowWidth);
      if (up)
            ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
      else  ObjectSet(name,OBJPROP_PRICE1,Low[i] -gap);
}

